--- old/usr/src/lib/libuutil/common/libuutil.h	2015-09-11 13:41:17.185705660 -0400
+++ new/usr/src/lib/libuutil/common/libuutil.h	2015-09-11 13:41:17.190650935 -0400
@@ -359,6 +359,8 @@
 
 void uu_avl_destroy(uu_avl_t *);	/* list must be empty */
 
+void uu_avl_recreate(uu_avl_t *);
+
 size_t uu_avl_numnodes(uu_avl_t *);
 
 void *uu_avl_first(uu_avl_t *);
--- old/usr/src/lib/libuutil/common/mapfile-vers	2015-09-11 13:41:17.310536435 -0400
+++ new/usr/src/lib/libuutil/common/mapfile-vers	2015-09-11 13:41:17.314429179 -0400
@@ -56,6 +56,7 @@
 	uu_avl_pool_create;
 	uu_avl_pool_destroy;
 	uu_avl_prev;
+	uu_avl_recreate;
 	uu_avl_remove;
 	uu_avl_teardown;
 	uu_avl_walk;
--- old/usr/src/lib/libuutil/common/uu_avl.c	2015-09-11 13:41:17.420952951 -0400
+++ new/usr/src/lib/libuutil/common/uu_avl.c	2015-09-11 13:41:17.424483843 -0400
@@ -21,10 +21,10 @@
 /*
  * Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ *
+ * Copyright 2015 Nexenta Systems, Inc.  All rights reserved.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include "libuutil_common.h"
 
 #include <stdlib.h>
@@ -274,6 +274,16 @@
 	uu_free(ap);
 }
 
+void
+uu_avl_recreate(uu_avl_t *ap)
+{
+	uu_avl_pool_t *pp = ap->ua_pool;
+
+	avl_destroy(&ap->ua_tree);
+	avl_create(&ap->ua_tree, &uu_avl_node_compare, pp->uap_objsize,
+	    pp->uap_nodeoffset);
+}
+
 size_t
 uu_avl_numnodes(uu_avl_t *ap)
 {
